#include "Derived.h"


void inheritedDataPublicInheritance(){
	//use in the Derived class the public inheritance
	//class Derived : public Base{
	Base b(1,2,3);
	int x = b.getPrivateData();	//getData from class Base
	cout << "in class Base, priv data = " << x << endl;
	Derived d(1, 2, 3, 4);
	x = d.publicData; //get public data from Base through class Derived
	cout << "in class Derived, public data from Base = " << x << endl;
	x = d.getProtectedData(); //get protected data from Base through class Derived
	cout << "in class Derived, protected data from Base = " << x << endl;
	x = d.getPrivateData(); //get private data from Base through class Derived
	cout << "in class Derived, private data from Base = " << x << endl;
	x = d.getNewData(); //get private data from class Derived
	cout << "in class Derived, private data from Derived = " << x << endl;
}

/*
void inheritedDataProtectedInheritance(){
	//for this func use in the Derived class the protected inheritance
	//class Derived : protected Base{
	Base b(1,2,3);
	int x = b.getPrivateData();	//getData from class Base
	cout << "in class Base, priv data = " << x << endl;
	Derived d(1, 2, 3, 4);
	
	//x = d.publicData; //get public data from Base through class Derived
	// error Base::publicData' not accessible because 'Derived' uses 'protected' to inherit from 'Base'
	//cout << "in class Derived, public data from Base = " << x << endl;
	
	//x = d.getProtectedData(); //get protected data from Base through class Derived
	// error 'Base::getProtectedData' not accessible because 'Derived' uses 'protected' to inherit from 'Base'
	//cout << "in class Derived, protected data from Base = " << x << endl;

	//x = d.getPrivateData(); //get private data from Base through class Derived
	//error 'Base::getPrivateData' not accessible because 'Derived' uses 'protected' to inherit from 'Base'
	//cout << "in class Derived, private data from Base = " << x << endl;
	
	x = d.getNewData(); //get private data from class Derived
	cout << "in class Derived, private data from Derived = " << x << endl;
}
*/
/*
void inheritedDataPrivateInheritance(){
	//for this func use in the Derived class the private inheritance
	//class Derived : private Base{
	Base b(1,2,3);
	int x = b.getPrivateData();	//getData from class Base
	cout << "in class Base, priv data = " << x << endl;
	Derived d(1, 2, 3, 4);

	//x = d.publicData; //get public data from Base through class Derived
	//error 'Base::publicData' not accessible because 'Derived' uses 'private' to inherit from 'Base'
	//cout << "in class Derived, public data from Base = " << x << endl;

	//x = d.getProtectedData(); //get protected data from Base through class Derived
	//error 'Base::getProtectedData' not accessible because 'Derived' uses 'private' to inherit from 'Base'
	//cout << "in class Derived, protected data from Base = " << x << endl;

	//x = d.getPrivateData(); //get private data from Base through class Derived
	//error 'Base::getPrivateData' not accessible because 'Derived' uses 'private' to inherit from 'Base'
	//cout << "in class Derived, private data from Base = " << x << endl;
	x = d.getNewData(); //get private data from class Derived
	cout << "in class Derived, private data from Derived = " << x << endl;
}
*/

int main(){
	inheritedDataPublicInheritance();
	//inheritedDataProtectedInheritance();
	//inheritedDataPrivateInheritance();
	return 0;
}