#ifndef DERIVED_H
#define DERIVED_H

#include "Base1.h"
#include "Base2.h"

class Derived : public Base1, public Base2{
private:
	int d3;
public:
	Derived():Base1(), Base2(){
		d3 = 0;
	}
	Derived(int d1, int d2, int d3, int d4):Base1(d1, d2), Base2(d1, d3){
		this->d3 = d4;
	}
	Derived(const Derived& d):Base1(d), Base2(d){
		d3 = d.d3;
	}
	~Derived(){
	}
	Derived& operator=(const Derived &d){
		if (this != &d){			
			Base1::operator=(d);
			Base2::operator =(d);
			this->d3 = d.d3;
		}
		return *this;
	}
	void setD3(int d){
		d3 = d;
	}
	int getD3(){
		return d3;
	}
	void h(){
		d3++;
	}
};
#endif