#include "Derived.h"
#include <iostream>
using namespace std;


void multipleInheritance(){
	Base1 b1(5);
	Base2 b2(10);
	Derived d(1,2,3);

	b1.f();
	cout << "base 1  : " << b1.getD1() << endl;

	b2.g();
	cout << "base 2  : " << b2.getD2() << endl;

	d.h();
	cout << "derived : " << d.getD3() << endl;

	//d.f();	//error C2385: ambiguous access of 'f'
	//cout << "derived : " << d.getD1() << " " << d.getD2() << endl;

	((Base1)d).f();
	cout << "derived : " << d.getD1() << " " << d.getD2() << endl;	//1 2

	Derived* dp = new Derived(1, 2, 3);
	((Base1*)dp)->f();
	cout << "derived : " << dp->getD1() << " " << dp->getD2() << endl;	//2 2

	((Base2*)dp)->f();
	cout << "derived : " << dp->getD1() << " " << dp->getD2() << endl;	//2 3
}

int main(){
	multipleInheritance();
	return 0;
}